//------------------------------------------------------------------
#property copyright "www.forex-TSD.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  White
#property indicator_width1  3
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1  20
#property indicator_level2  80
#property indicator_levelcolor DarkGray


//
//
//
//
//

extern string ForSymbol      = "";
extern int    StartFrom      = 6;
extern int    EndWith        = 48;
extern int    BarsToDraw     = 150;
extern int    BarsWidth      = 4;
extern string UniqueID       = "Swami Aroon Oscillator";
extern bool   GenericVisible = true;
extern bool   SwamiVisible   = true;
extern color  ColorUp        = LimeGreen;
extern color  ColorDown      = HotPink;
extern bool   Inverted       = false;


double aroon[];
double step;
double totalSteps;
int    window;
bool   returnBars;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   int type = DRAW_NONE; if (GenericVisible) type = DRAW_LINE;
      SetIndexBuffer(0,aroon); SetIndexStyle(0,type);
      if (ForSymbol=="") ForSymbol=Symbol();
      
         //
         //
         //
         //
         //
         
         indicatorFileName = WindowExpertName();
         returnBars        = (ForSymbol=="returnBars"); if (returnBars) return(0);
         StartFrom  = MathMax(StartFrom, 6);
         EndWith    = MathMin(EndWith  ,99);
         totalSteps = EndWith-StartFrom+1.0;
         step       = 100.0/(totalSteps-1);
      IndicatorShortName(UniqueID+" "+ForSymbol);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID+" "+ForSymbol+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i); if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { aroon[0] = limit+1;  return(0); }
         if (ForSymbol!=Symbol()) limit = MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,0,indicatorFileName,"returnBars",0,0)));
         
         window = WindowFind(UniqueID+" "+ForSymbol);

         //
         //
         //
         //
         //

         for (int i=limit; i>=0 ; i--)
         {
            double high = iHigh(ForSymbol,0,i); double highest = 0;
            double low  = iLow(ForSymbol,0,i);  double lowest  = 0;
            
            //
            //
            //
            //
            //
   
            aroon[i] = 0;         
            for (int k=1; k<EndWith; k++)
            {
               if (iHigh(ForSymbol,0,i+k) > high) { highest = k; high = iHigh(ForSymbol,0,i+k); }
               if ( iLow(ForSymbol,0,i+k) < low ) { lowest  = k; low  =  iLow(ForSymbol,0,i+k); }
               if (k>=StartFrom)
               {
                  double AroonUp = (k-highest+1.0)/(k*1.0);
                  double AroonDn = (k-lowest +1.0)/(k*1.0);
                  double AroonOs = 0.5+(AroonUp-AroonDn)/2.0;
                  if (i<BarsToDraw)
                  {
                     double temp = AroonOs; if (Inverted) temp = 1.0-AroonOs; 
                     if (SwamiVisible) plot(k,(k-StartFrom)*step,(k-StartFrom+1)*step,i,i,gradientColor(temp*50.0,51,ColorDown,ColorUp),BarsWidth);
                  }                     
                  aroon[i] += AroonOs;
               }
            }
            aroon[i] = MathMin(MathMax(100.0*aroon[i]/totalSteps,0),100); if (Inverted) aroon[i] = 100.0-aroon[i];
         }
         
   //
   //
   //
   //
   //

   SetIndexDrawBegin(0,Bars-BarsToDraw);
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void plot(string namex,double valueA, double valueB, int shiftA, int shiftB, double theColor, int width=0,int style=STYLE_SOLID)
{
   string   name = UniqueID+":"+namex+Time[shiftA];
   
   //
   //
   //
   //
   //
   
   if (ObjectFind(name) == -1) 
   {
       ObjectCreate(name,OBJ_TREND,window,Time[shiftA],valueA,Time[shiftB],valueB);
          ObjectSet(name,OBJPROP_RAY,false);
          ObjectSet(name,OBJPROP_BACK,true);
          ObjectSet(name,OBJPROP_STYLE,style);
          ObjectSet(name,OBJPROP_WIDTH,width);
   }
   ObjectSet(name,OBJPROP_COLOR,theColor);
   ObjectSet(name,OBJPROP_PRICE1,valueA);
   ObjectSet(name,OBJPROP_PRICE2,valueB);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

color gradientColor(int tstep, int ttotalSteps, color from, color to)
{
   color newBlue  = getColor(tstep,ttotalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(tstep,ttotalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(tstep,ttotalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int ttotalSteps, color from, color to)
{
   double tstep = (from-to)/(ttotalSteps-1.0);
   return(MathRound(from-tstep*stepNo));
}